"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = undefined && undefined.__metadata || function (k, v) {
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var src_1 = require("../../src");
function isPromiseLike(result) {
    return result && typeof result.then === "function";
}
exports.isPromiseLike = isPromiseLike;

var ComputedAsync = function () {
    function ComputedAsync(options) {
        var _this = this;

        _classCallCheck(this, ComputedAsync);

        this.options = options;
        this.status = src_1.observable({
            busy: false,
            failed: false,
            error: null
        });
        this.version = 0;
        this.atom = new src_1.Atom(function () {
            return _this.wake();
        }, function () {
            return _this.sleep();
        });
        this.cachedValue = options.init;
    }

    _createClass(ComputedAsync, [{
        key: "wake",
        value: function wake() {
            var _this2 = this;

            this.sleep();
            this.monitor = src_1.observe(function () {
                return _this2.observe();
            }, this.options.delay);
        }
    }, {
        key: "observe",
        value: function observe() {
            var _this3 = this;

            var thisVersion = ++this.version;
            if (this.options.revert) {
                this.cachedValue = this.options.init;
                this.atom.reportChanged();
            }
            var current = function current(f) {
                return function (arg) {
                    if (_this3.version === thisVersion) {
                        f(arg);
                    }
                };
            };
            try {
                var possiblePromise = this.options.fetch();
                if (!isPromiseLike(possiblePromise)) {
                    this.stopped(false, undefined, possiblePromise);
                } else {
                    this.starting();
                    possiblePromise.then(current(function (v) {
                        return _this3.stopped(false, undefined, v);
                    }), current(function (e) {
                        return _this3.handleError(e);
                    }));
                }
            } catch (x) {
                this.handleError(x);
            }
        }
    }, {
        key: "starting",
        value: function starting() {
            this.status.busy = true;
        }
    }, {
        key: "stopped",
        value: function stopped(f, e, v) {
            this.status.busy = false;
            this.status.failed = f;
            this.status.error = e;
            if (v !== this.cachedValue) {
                this.cachedValue = v;
                this.atom.reportChanged();
            }
        }
    }, {
        key: "handleError",
        value: function handleError(e) {
            var newValue = this.options.init;
            if (this.options.error) {
                try {
                    newValue = this.options.error(e);
                } catch (x) {
                    //
                }
            }
            this.stopped(true, e, newValue);
        }
    }, {
        key: "sleep",
        value: function sleep() {
            var monitor = this.monitor;
            this.monitor = undefined;
            if (monitor) {
                monitor.unobserve();
            }
        }
    }, {
        key: "value",
        get: function get() {
            this.atom.reportObserved();
            if (this.status.failed && this.options.rethrow) {
                throw this.status.error;
            }
            return this.cachedValue;
        }
    }]);

    return ComputedAsync;
}();

__decorate([src_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ComputedAsync.prototype, "starting", null);
__decorate([src_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean, Object, Object]), __metadata("design:returntype", void 0)], ComputedAsync.prototype, "stopped", null);
function computedAsync(init, fetch, delay) {
    if (arguments.length === 1) {
        return new ComputedAsync(init);
    }
    return new ComputedAsync({
        init: init,
        fetch: fetch,
        delay: delay
    });
}
exports.computedAsync = computedAsync;
//# sourceMappingURL=computed-async.js.map