"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

Object.defineProperty(exports, "__esModule", { value: true });
var global_state_1 = require("./global-state");
var observer_1 = require("./observer");
var utils_1 = require("./utils");
/**
 * getter setter 控制器
 */

var Atom = function () {
    function Atom() {
        var onBecomeObservedHandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : utils_1.noop;
        var onBecomeUnobservedHandler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : utils_1.noop;

        _classCallCheck(this, Atom);

        /**
         * 与这个 atom 相关的 reactions
         */
        this.reactions = new Set();
        /**
         * 是否已经追踪了
         */
        this.isBeingTracked = false;
        this.onBecomeObservedHandler = onBecomeObservedHandler;
        this.onBecomeUnobservedHandler = onBecomeUnobservedHandler;
    }
    /**
     * 上报：响应变量被使用，初始时触发 onBecomeObservedHandler
     */


    _createClass(Atom, [{
        key: "reportObserved",
        value: function reportObserved() {
            observer_1.startBatch();
            if (global_state_1.globalState.currentReaction) {
                // 绑定上当前 reaction
                this.reactions.add(global_state_1.globalState.currentReaction);
            }
            if (!this.isBeingTracked) {
                this.isBeingTracked = true;
                this.onBecomeObservedHandler();
            }
            observer_1.endBatch();
        }
        /**
         * 上报：响应变量发生了修改，会重新触发 observe
         */

    }, {
        key: "reportChanged",
        value: function reportChanged() {
            // 执行它
            this.reactions.forEach(function (reaction) {
                observer_1.runReactionAsync(reaction);
            });
        }
        /**
         * 取消 observe
         */

    }, {
        key: "unobserve",
        value: function unobserve() {
            this.isBeingTracked = false;
            this.reactions.clear();
            this.onBecomeUnobservedHandler();
        }
    }]);

    return Atom;
}();

exports.Atom = Atom;
//# sourceMappingURL=atom.js.map