"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var global_state_1 = require("../global-state");
var native = Set.prototype;
var masterValue = Symbol("Set master value");
var getters = ["has"];
var iterators = ["forEach", "keys", "values", "entries", Symbol.iterator];
var all = ["add", "delete", "clear"].concat(getters, iterators);
function shim(target, bindCurrentReaction, queueRunReactions, proxyValue) {
    target.$raw = {};
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        var _loop = function _loop() {
            var method = _step.value;

            // tslint:disable-next-line:space-before-function-paren only-arrow-functions
            target.$raw[method] = function () {
                native[method].apply(target, arguments);
            };
        };

        for (var _iterator = all[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            _loop();
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        var _loop2 = function _loop2() {
            var getter = _step2.value;

            // tslint:disable-next-line:space-before-function-paren only-arrow-functions
            target[getter] = function (value) {
                var result = native[getter].apply(this, arguments);
                global_state_1.globalState.event.emit("get", { target: target, key: null, value: result });
                result = proxyValue(this, value, result);
                bindCurrentReaction(this, value);
                return result;
            };
        };

        for (var _iterator2 = getters[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            _loop2();
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }

    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
        var _loop3 = function _loop3() {
            var iterator = _step3.value;

            // tslint:disable-next-line:space-before-function-paren only-arrow-functions
            target[iterator] = function () {
                bindCurrentReaction(this, masterValue);
                return native[iterator].apply(this, arguments);
            };
        };

        for (var _iterator3 = iterators[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            _loop3();
        }
        // tslint:disable-next-line:space-before-function-paren only-arrow-functions
    } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
            }
        } finally {
            if (_didIteratorError3) {
                throw _iteratorError3;
            }
        }
    }

    target.add = function (value) {
        var has = this.has(value);
        var result = native.add.apply(this, arguments);
        global_state_1.globalState.event.emit("set", { target: target, key: null, value: value, oldValue: null });
        if (!has) {
            queueRunReactions(this, value);
            queueRunReactions(this, masterValue);
        }
        return result;
    };
    // tslint:disable-next-line:space-before-function-paren only-arrow-functions
    target.delete = function (value) {
        var has = this.has(value);
        var result = native.delete.apply(this, arguments);
        global_state_1.globalState.event.emit("deleteProperty", { target: target, key: null });
        if (has) {
            queueRunReactions(this, value);
            queueRunReactions(this, masterValue);
        }
        return result;
    };
    // tslint:disable-next-line:space-before-function-paren only-arrow-functions
    target.clear = function () {
        var size = this.size;
        var result = native.clear.apply(this, arguments);
        if (size) {
            queueRunReactions(this, masterValue);
        }
        return result;
    };
    Object.defineProperty(target, "size", {
        get: function get() {
            var proto = Object.getPrototypeOf(this);
            var size = Reflect.get(proto, "size", this);
            bindCurrentReaction(this, masterValue);
            return size;
        }
    });
    return target;
}
exports.default = shim;
//# sourceMappingURL=set.js.map