"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

Object.defineProperty(exports, "__esModule", { value: true });

var Event = function () {
    function Event() {
        _classCallCheck(this, Event);

        // 所有事件
        this.events = new Map();
    }

    _createClass(Event, [{
        key: "on",
        value: function on(eventType, callback) {
            var event = {
                callback: callback
            };
            if (this.events.get(eventType)) {
                // 存在, push 一个事件监听
                this.events.get(eventType).push(event);
            } else {
                // 不存在, 赋值
                this.events.set(eventType, [event]);
            }
        }
        /**
         * 取消订阅
         */

    }, {
        key: "off",
        value: function off(eventType, callback) {
            if (!this.events.get(eventType)) {
                return false;
            }
            var events = this.events.get(eventType).filter(function (event) {
                return event.callback !== callback;
            });
            this.events.set(eventType, events);
            return true;
        }
        /**
         * 广播事件
         */

    }, {
        key: "emit",
        value: function emit(eventType, context) {
            if (!eventType || !this.events.get(eventType)) {
                return false;
            }
            this.events.get(eventType).forEach(function (event) {
                event.callback(context);
            });
        }
    }]);

    return Event;
}();

exports.Event = Event;
//# sourceMappingURL=index.js.map