"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var index_1 = require("../src/index");

var Clock = function () {
    function Clock() {
        var _this = this;

        _classCallCheck(this, Clock);

        this.intervalHandler = null;
        this.currentDateTime = 1;
        this.atom = new index_1.Atom(function () {
            return _this.startTicking();
        }, function () {
            return _this.stopTicking();
        });
    }

    _createClass(Clock, [{
        key: "stopAtom",
        value: function stopAtom() {
            this.atom.unobserve();
        }
    }, {
        key: "getTime",
        value: function getTime() {
            this.atom.reportObserved();
            return this.currentDateTime;
        }
    }, {
        key: "startTicking",
        value: function startTicking() {
            this.currentDateTime++;
            this.atom.reportChanged();
        }
    }, {
        key: "stopTicking",
        value: function stopTicking() {
            clearInterval(this.intervalHandler);
            this.intervalHandler = null;
        }
    }]);

    return Clock;
}();

ava_1.default("basic test", function (t) {
    var time = 0;
    var clock = new Clock();
    index_1.observe(function () {
        time = clock.getTime();
    });
    clock.startTicking();
    clock.startTicking();
    clock.startTicking();
    return Promise.resolve().then(function () {
        return t.true(time === 5);
    });
});
ava_1.default("unobservable", function (t) {
    var time = 0;
    var clock = new Clock();
    index_1.observe(function () {
        time = clock.getTime();
    });
    clock.startTicking();
    clock.startTicking();
    clock.stopAtom();
    return Promise.resolve().then(function () {
        return t.true(time === 4);
    });
});
//# sourceMappingURL=atom.test.js.map